#ifndef ASM_ARCH_FPU_H
#define ASM_ARCH_FPU_H

#if defined(CONFIG_CPU_BULVERDE)

#undef lazy_fpu

#define enable_concan() do { 			\
	int volatile __reg;			\
	asm volatile(				\
	"mrc p15, 0, %0, c15, c1, 0\n\t"	\
	"orr %0, %0, #0x3\n\t"			\
	"mcr p15, 0, %0, c15, c1, 0"		\
	::"r"(__reg));				\
}while(0)

#define disable_concan() do {			\
	int volatile __reg;			\
	asm volatile (				\
	"mrc p15, 0, %0, c15, c1, 0\n\t"	\
	"bic %0, %0, #0x3\n\t"			\
	"mcr p15, 0, %0, c15, c1, 0"		\
	::"r"(__reg));				\
}while(0)

#define lazy_fpu(tsk) do{		\
	/* need to save? */		\
	if( tsk->flags & PF_USEDFPU)  	\
		save_concan(tsk);	\
}while(0)

extern void load_concan(void);
extern void save_concan(struct task_struct *tsk);
extern void __load_concan(struct task_struct *tsk);
extern void __save_concan(struct task_struct *tsk);

#endif

#endif
