#ifndef _ASM_ARCH_KEYPAD_H
#define _ASM_ARCH_KEYPAD_H

#include <linux/types.h>

#define KPIOGET_INTERVAL	_IOR('k', 0, __u16)
#define KPIOGET_IGNMULTI	_IOR('k', 1, __u16)
#define KPIOSET_INTERVAL	_IOW('k', 0, __u16)
#define KPIOSET_IGNMULTI	_IOW('k', 1, __u16)

#ifdef __KERNEL__

#define KP_DIRECT 	0x1
#define KP_MATRIX	0x2

struct kp_event{
	unsigned int jiffies;
	unsigned int flags;
	unsigned int direct; 
	unsigned int rotary;
	unsigned int matrix[5]; 
};

extern int kp_init(void);
extern int kp_wait(struct kp_event *kpe, int timeout);
extern unsigned int kp_poll(struct file *file, poll_table *wait);
extern int kp_direct_scan(void);
extern int kp_matrix_scan(void);

#endif /* __KERNEL__ */

#endif
