/*
 * $Id$
 */

#ifndef __LINUX_MTD_XIP_H__
#define __LINUX_MTD_XIP_H__



#ifdef CONFIG_XIP_KERNEL
#ifdef CONFIG_ARCH_PXA
#include <asm/arch/pxa-regs.h>
#define xip_irqpending() (ICIP & ICMR)
#else
#warning "No known way to check for IRQ pending on this arch"
#define xip_irqpending() (0)
#endif /* ARCH */


#define xip_cli() do { cli(); } while(0)
#define xip_sti() do { sti(); } while(0)

#define __xipram __attribute__ ((__section__ (".text.xipram")))
#else /* !CONFIG_XIP_KERNEL */
#define xip_cli() do { } while(0)
#define xip_sti() do { } while(0)
#define xip_irqpending() (0)
#define __xipram
#endif /* CONFIG_XIP_KERNEL */

#endif /* __LINUX_MTD_XIP_H__ */
