/*
 * include/linux/pxa_gpio.h
 *
 *  Author:  Florian PANTALEAO
 *
 * Copyright (C) 2007 Mobisense Systems.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __PXA_GPIO_H
#define __PXA_GPIO_H

typedef enum {
  PXA_GPIO_NONE = 0,
  PXA_GPIO_INPUT,
  PXA_GPIO_OUTPUT,
  PXA_GPIO_SERVO,
  PXA_GPIO_PWM,
  PXA_GPIO_TIMER,
  PXA_GPIO_CLOCK,
  PXA_GPIO_SYSTEM
} pxa_gpio_use_t;

struct pxa_gpio_add {
  unsigned int gpio;
  unsigned int input;
  unsigned int init_state;
};

struct pxa_gpio_get {
  unsigned int gpio;
  unsigned int state;
};

struct pxa_gpio_rem {
  unsigned int gpio;
  unsigned int input;
};

#define PXAIOCGPIOADD	_IOWR('m',10,struct pxa_gpio_add)
#define PXAIOCGPIOREM	_IOW ('m',11,struct pxa_gpio_rem)
#define PXAIOCGPIOGET	_IOWR('m',12,struct pxa_gpio_get)
#define PXAIOCGPIOSET	_IOW ('m',13,unsigned int)
#define PXAIOCGPIOCLR	_IOW ('m',14,unsigned int)

extern int pxa_gpio_use(unsigned int gpio, pid_t pid, pxa_gpio_use_t use);
extern int pxa_gpio_unuse(unsigned int gpio, pid_t pid, pxa_gpio_use_t use);

#endif
