/*
 *  include/linux/pxa_servo.h
 *
 *  Author:  Florian PANTALEAO
 *
 *  Copyright (C) 2007 Mobisense Systems.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __PXA_SERVO_H
#define __PXA_SERVO_H

#define NR_PXA_SERVO             32
#define PXA_SERVO_MIN_DELAY_US    5
#define PXA_SERVO_MAX_DELAY_US 3000

struct pxa_servo_add {
  unsigned int gpio;
  unsigned int delay;
  unsigned int id;
};

struct pxa_servo_rem {
  unsigned int id;
};

struct pxa_servo_val {
  unsigned int id;
  unsigned int delay;
};

struct pxa_servo_chg {
  unsigned int nb;
  struct pxa_servo_val *val;
};

#define PXAIOCSRVADD	_IOWR('m',0,struct pxa_servo_add)
#define PXAIOCSRVREM	_IOWR('m',1,struct pxa_servo_rem)
#define PXAIOCSRVCHG	_IOWR('m',2,struct pxa_servo_chg)

#endif
