#ifndef _ASM_ARCH_SRAM_H
#define _ASM_ARCH_SRAM_H

#define SRAM_REG(x)		(* (volatile u32*)(x) )

#define SRAM_SIZE		0x40000	/* 4 * 64K */

#define SRAM_REGS_PHYS		0x58000000
#define SRAM_MEM_PHYS		0x5c000000

#define IMPMCR(base)		SRAM_REG((u32)(base) + 0x0)
#define IMPMSR(base)		SRAM_REG((u32)(base) + 0x8)

extern void get_sram_base(unsigned long *pregs, unsigned long *pmem);

#endif
